MAX_CONTROL_POINTS <- 8
TEAM_UNASSIGNED <- 0
TF_TEAM_BLUE <- Constants.ETFTeam.TF_TEAM_BLUE

function OnPostSpawn() {
	CaptureInProgress <- false
	Elevator <- Entities.FindByName(null, "cp_2_plat")
	FlagZone <- Entities.FindByName(null, "cp_2_interrupt_bludetect")
	StartPath <- Entities.FindByName(null, "cap_track1")
	EndPath <- Entities.FindByName(null, "cap_track8")

	StartHeight <- StartPath.GetOrigin().z
	EndHeight <- EndPath.GetOrigin().z
	TotalHeight <- EndHeight - StartHeight

	PointIndex <- 1
	PointTeamIndex <- MAX_CONTROL_POINTS * TF_TEAM_BLUE + PointIndex

	ObjectiveResource <- Entities.FindByClassname(null, "tf_objective_resource")

	NetProps.SetPropBoolArray(ObjectiveResource, "m_bTeamCanCap", true, PointTeamIndex)
	NetProps.SetPropFloatArray(ObjectiveResource, "m_flTeamCapTime", 10000, PointTeamIndex)
	NetProps.SetPropBoolArray(ObjectiveResource, "m_bCPCapRateScalesWithPlayers", false, PointIndex)

	FlagZone.ValidateScriptScope()
	local scope = FlagZone.GetScriptScope()

	scope.OnStartTouchAll <- OnEnterCaptureArea
	scope.OnEndTouch <- OnLeaveCaptureArea
	scope.CaptureAreaThink <- CaptureAreaThink
	FlagZone.ConnectOutput("OnStartTouchAll", "OnStartTouchAll")
	FlagZone.ConnectOutput("OnEndTouch", "OnEndTouch")
	AddThinkToEnt(FlagZone, "CaptureAreaThink")
}

function OnEnterCaptureArea[this]() {
	NetProps.SetPropIntArray(ObjectiveResource, "m_iCappingTeam", TF_TEAM_BLUE, PointIndex)

	NetProps.SetPropIntArray(ObjectiveResource, "m_iNumTeamMembers", 1, PointTeamIndex)
	CaptureInProgress <- true

	SendGlobalGameEvent("controlpoint_starttouch", {
		player = activator.entindex()
		area = PointIndex
	})
}

function OnLeaveCaptureArea[this]() {
	NetProps.SetPropIntArray(ObjectiveResource, "m_iNumTeamMembers", 0, PointTeamIndex)
	CaptureInProgress <- false

	SendGlobalGameEvent("controlpoint_endtouch", {
		player = activator.entindex()
		area = PointIndex
	})
}

function CaptureAreaThink[this]() {
	local fraction = (EndHeight - Elevator.GetOrigin().z) / TotalHeight
	if (fraction < 0) fraction = 0
	if (fraction > 1) fraction = 1

	if (fraction >= 0.975 && !CaptureInProgress) {
		NetProps.SetPropIntArray(ObjectiveResource, "m_iCappingTeam", TEAM_UNASSIGNED, PointIndex)
	}

	NetProps.SetPropFloatArray(ObjectiveResource, "m_flCapPercentages", fraction, PointIndex)
	NetProps.SetPropFloatArray(ObjectiveResource, "m_flLazyCapPerc", fraction, PointIndex)

	return -1
}
